;This is the first ARM Assembly language program you see in the lab
;This program template was partially created by Airs Lin @ 2017 California State University of Los Angeles.
;When you write your program, you could have your info at the top document block
;For Example:  Your Name, Student Number, what the program is for, and what it does etc.
 
; Constant Variable Here
STACK_ADDR_123G EQU     0x20008000
 
            THUMB
 
; Vector Table Mapped to Address 0 at Reset
; Linker requires __Vectors to be exported
 
            AREA    RESET, DATA, READONLY
            EXPORT  __Vectors
__Vectors
            DCD     STACK_ADDR_123G         ; stack pointer value when stack is empty
            DCD     Reset_Handler           ; reset vector
 
            ALIGN
 
; The program
; Linker requires Reset_Handler
 
            AREA    |.text|, CODE, READONLY
            ENTRY                           ; mark first instruction to execute
            EXPORT Reset_Handler
Reset_Handler
;;;;;;;;;; Your Main Code Starts from the next line ;;;;;;;;;;;;
 
            MOV     R0, #12
 
 
            ADD     R0, R0, #4
			
			LDR R2, =ConstData	;
			MOVS R3, #0x02
	
			MOV R6, #0x01
			MOV R7, #0x20
			TST R6, R7
	
	
	
Loop
			LDR R1, [R2, #0]
			LDR R0, =VarData
			STR R1,[R0,#0]
			LDR R1,[R2,#4]
			STR R1, [R0, #4]
			ADDS R2, #8
			SUBS R3, #1
			BNE Loop
DeadLoop    B       DeadLoop
 
; The constant variable area
; The value will be stored on ROM segment
            AREA    ConstantVariables, DATA, READONLY
				; Place constant data here
ConstData  DCD 0x0000000A, 0x0000000B, 0x00000010, 10*10
; The variables area
; The variables will be assigned to RAM area
            AREA    Variables, DATA, READWRITE
 ; PLace variable data here
VarData	SPACE 8
            END     ; End of the program